package com.qmth.teachcloud.mark.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.teachcloud.common.bean.dto.mark.manage.MarkArbitrateDto;
import com.qmth.teachcloud.common.entity.MarkStudent;
import com.qmth.teachcloud.common.service.MarkQuestionService;
import com.qmth.teachcloud.common.service.MarkStudentService;
import com.qmth.teachcloud.mark.entity.MarkArbitrateHistory;
import com.qmth.teachcloud.mark.mapper.MarkArbitrateHistoryMapper;
import com.qmth.teachcloud.mark.service.MarkArbitrateHistoryService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * <p>
 * 仲裁记录表 服务实现类
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
@Service
public class MarkArbitrateHistoryServiceImpl extends ServiceImpl<MarkArbitrateHistoryMapper, MarkArbitrateHistory> implements MarkArbitrateHistoryService {

    @Resource
    private MarkQuestionService markQuestionService;
    @Resource
    private MarkStudentService markStudentService;

    @Override
    public IPage<MarkArbitrateDto> pageArbitrate(Long examId, String paperNumber, Integer groupNumber, Integer pageNumber, Integer pageSize) {
        Page<MarkArbitrateDto> page = new Page<>(pageNumber, pageSize);
        IPage<MarkArbitrateDto> markArbitrateDtoIPage = this.baseMapper.pageArbitrate(page, examId, paperNumber, groupNumber);
        for (MarkArbitrateDto arbitrateDto : markArbitrateDtoIPage.getRecords()) {
            if (arbitrateDto.getStudentId() != null) {
                MarkStudent markStudent = markStudentService.getById(arbitrateDto.getStudentId());
                if (markStudent != null) {
                    arbitrateDto.setStudentCode(markStudent.getStudentCode());
                    arbitrateDto.setStudentName(markStudent.getStudentName());
                }
            }
            arbitrateDto.setStatusName(arbitrateDto.getStatus().getName());
            arbitrateDto.setGroupQuestions(markQuestionService.assembleGroupQuestionsByExamIdAndPaperNumberAndNumber(examId, paperNumber, arbitrateDto.getGroupNumber()));
        }
        return markArbitrateDtoIPage;
    }
}
